/*
 * Huk: a multi-threaded modular bruteforce tool 
 *
 * Written by Carlos Barros <barros [at] barrossecurity [dot] com>
 *
 * Copyright (C) 2006, Barrossecurity
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __BRUTE_H__
#define __BRUTE_H__

#include "dispatcher.h"
#include "modules.h"

#include <libhuk/libnet.h>
#include <libhuk/list.h>

/*=[ Defines ]=*/

// abort sequence
#define NONE			0
#define	ABORT_REQUEST		1
#define	ABORTED			2

/*=[ Structs ]=*/
typedef struct
{
	s_libnet		*libnet;
	s_linked_list		*params;
	char			*user;
	char			*passwd;
	s_module_definition	*module;
}s_brute_param;

/*=[ Prototypes ]=*/
int do_brute_force();

#endif
