/*
 * Huk: a multi-threaded modular bruteforce tool 
 *
 * Written by Carlos Barros <barros [at] barrossecurity [dot] com>
 *
 * Copyright (C) 2006, Barrossecurity
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __DISPATCHER_H__
#define __DISPATCHER_H__

/*=[ Defines ]=*/
#define DEFAULT_TIMEOUT		30		// seg

/*=[ Structs ]=*/

typedef struct
{
	int	pid;
	int	retcode;
	void	*argument;
}s_task;

/*=[ Prototypes ]=*/
typedef struct
{
	int	maxtasks;		// Max tasks available
	int	task_timeout;		// Tasks timeout
	s_task	*tasks;			// List of active tasks
}s_dispatcher;

/*=[ Prototypes ]=*/

s_dispatcher *dispatcher_new(int,int);
void dispatcher_free(s_dispatcher *);
int dispatcher_slotavailable(s_dispatcher*);
int dispatcher_newtask(s_dispatcher *,int (*)(void *),void *);
s_task *dispatcher_waitpids(s_dispatcher *);
void dispatcher_free_slot(s_dispatcher *, int);

#endif
