/*
 * Huk: a multi-threaded modular bruteforce tool 
 *
 * Written by Carlos Barros <barros [at] barrossecurity [dot] com>
 *
 * Copyright (C) 2006, Barrossecurity
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/*
 * Code "ripped" (with some mods) from: 
 * http://www.koders.com/c/fidDF059C42D2FEC30FDCBF3363492CEE8F24ED5252.aspx
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "wrappers.h"

/*=[ Prototypes ]=*/
char base64_convert(char);

/*
** Public methods
*/

char *base64_encode(char *src, int size)
{
	int 		i;
	char 		*out, *p;

	if(!src) return NULL;
	if(!size) size= strlen((char *)src);

	out = do_calloc(sizeof(char), size*4/3+4);
	p = out;

	for(i=0;i<size;i+=3) 
	{
		unsigned char b1 = 0, b2 = 0, b3 = 0, b4 = 0, b5 = 0, b6 = 0, b7=0;

		b1 = src[i];

		if(i+1<size) b2 = src[i+1];
		if(i+2<size) b3 = src[i+2];

		b4= b1>>2;
		b5= ((b1&0x3)<<4)|(b2>>4);
		b6= ((b2&0xf)<<2)|(b3>>6);
		b7= b3&0x3f;

		*p++= base64_convert(b4);
		*p++= base64_convert(b5);

		if(i+1<size) *p++= base64_convert(b6);
		else *p++= '=';

		if(i+2<size) *p++= base64_convert(b7);
		else *p++= '=';
	}

	return out;
}

/*
** Private methods
*/

char base64_convert(char u)
{
	if(u < 26)  return 'A'+u;
	if(u < 52)  return 'a'+(u-26);
	if(u < 62)  return '0'+(u-52);
	if(u == 62) return '+';

	return '/';
}

