/*
 * Huk: a multi-threaded modular bruteforce tool 
 *
 * Written by Carlos Barros <barros [at] barrossecurity [dot] com>
 *
 * Copyright (C) 2006, Barrossecurity
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __COMMON_H__
#define __COMMON_H_

/*=[ Macros ]=*/
#define abort(msg...) { fprintf(stderr,msg); fprintf(stderr,"\n"); exit(EXIT_FAILURE); }
#define warning(msg...) { fprintf(stderr,msg); fprintf(stderr,"\n"); }
#define OUTPUT(fmt...)	{ fprintf(stdout,fmt); fflush(stdout); }
#define OUTPUT_ERROR(fmt...)	{ fprintf(stderr,fmt); fflush(stderr); }

/*=[ Defines ]=*/
#define ERROR			1	// do not touch this one
#define	SUCCESS			0

#define	READ_TIMEOUT		500000	// read time-out (us)

// some defaults
#define	DEFAULT_USERNAME	"nobody"
#define	DEFAULT_WORDLIST	"passwd.lst"
#define	DEFAULT_CONNECTIONS	5
#define MAX_CONNECTIONS		100

#endif
