/*
 * Huk: a multi-threaded modular bruteforce tool 
 *
 * Written by Carlos Barros <barros [at] barrossecurity [dot] com>
 *
 * Copyright (C) 2006, Barrossecurity
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __LIB_NET_H__
#define __LIB_NET_H__

#include <netinet/in.h>

/*=[ Defines ]=*/
#define DIRECT          0
#define SOCKS4          1
#define SOCKS5          2

/*=[ Structs ]=*/
typedef struct
{
	struct in_addr	h_address;
	char		*h_name;
}s_libnet_hp;

typedef struct
{
        s_libnet_hp  	*hp;
	int		port;
        s_libnet_hp  	*shp;
	int		sport;
	char		*suser;
	char		*spass;
        int             sock;
        int             type;

}s_libnet;

/*=[ Prototypes ]=*/
s_libnet *net_new(char *, int);
void net_free(s_libnet *);
void net_close(s_libnet *);
void net_connect(s_libnet *);
int net_write(s_libnet *, void *, int);
int net_read(s_libnet *, void **, int);

#endif
