/*
 * Huk: a multi-threaded modular bruteforce tool 
 *
 * Written by Carlos Barros <barros [at] barrossecurity [dot] com>
 *
 * Copyright (C) 2006, Barrossecurity
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __LIST_H__
#define __LIST_H__

/*=[ Structs ]=*/
struct linked_list
{
	void			*content;
	struct linked_list	*next;
};
typedef struct linked_list s_linked_list;

/*=[ Prototypes ]=*/
typedef void (*list_callback)(void *);

s_linked_list *list_new(void);
void list_append(s_linked_list **, void *, int);
void list_clean(s_linked_list **, list_callback);
int list_count(s_linked_list **);

#endif
