/*
 * Huk: a multi-threaded modular bruteforce tool 
 *
 * Written by Carlos Barros <barros [at] barrossecurity [dot] com>
 *
 * Copyright (C) 2006, Barrossecurity
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __MODULES_LIB_H__
#define __MODULES_LIB_H__

#include "libnet.h"
#include "list.h"

/*=[ Macros ]=*/
#define DEFINE_MODULE(key,descr,port,params,check,func) s_module_definition module_definition = {key,descr,port,params,check,func};
#define END_OF_PARAMS_LIST	{ NULL,NULL,0 }

/*=[ Defines ]=*/
#define	INVALID_LOGIN		0
#define BRUTE_ERROR		1	// do not touch this one
#define	VALID_LOGIN		2

/*=[ Structs ]=*/

typedef struct
{
	char			*param_name;
	char			*param_value;
}s_module_params;

typedef struct
{
	char			*param_name;
	char			*param_descr;
	int			param_required;
}s_module_params_list;

typedef struct
{
	s_libnet		*libnet;
	s_linked_list		*params;
	char			*user;
	char			*passwd;
}s_mod_context;

typedef struct
{
	char 			*module_key;
	char			*module_descr;
	int			default_port;
	s_module_params_list	*params_list;
	int			(*module_validate_params)(s_linked_list **);
	int			(*module_function)(s_mod_context *);
}s_module_definition;

/*=[ Prototypes ]=*/
char *modules_get_param(s_linked_list **, char *);

#endif
