/*
 * Huk: a multi-threaded modular bruteforce tool 
 *
 * Written by Carlos Barros <barros [at] barrossecurity [dot] com>
 *
 * Copyright (C) 2006, Barrossecurity
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __SOCKS4_H__
#define __SOCKS4_H__

#include "libnet.h"

/*=[ Defines ]=*/

#define	SOCKS4_VERSION			0x04
#define	SOCKS4_CMD_TCP_CONNECT		0x01
#define	SOCKS4_RESPONSE_GRANTED		0x5a
#define	SOCKS4_RESPONSE_REJECTED	0x5b
#define	SOCKS4_RESPONSE_IDENT_FAILED	0x5c
#define	SOCKS4_RESPONSE_IDENT_CONFLICT	0x5d

/*=[ Structs ]=*/
typedef struct
{
	unsigned char	ver;
	unsigned char	cmd;
	unsigned short	port;
	unsigned int	ip;
	int		userid;
}s_socks4_request;

/*=[ Prototypes ]=*/
void socks4_connect(s_libnet *);

#endif
