/*
 * Huk: a multi-threaded modular bruteforce tool 
 *
 * Written by Carlos Barros <barros [at] barrossecurity [dot] com>
 *
 * Copyright (C) 2006, Barrossecurity
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __SOCKS5_H__
#define __SOCKS5_H__

#include "libnet.h"

/*=[ Defines ]=*/
#define	SOCKS5_VERSION				0x05
#define	SOCKS5_AUTH_NONE			0x00
#define	SOCKS5_AUTH_USER_PASS			0x02
#define	SOCKS5_RESPONSE_AUTH_INVALID		0xff
#define	SOCKS5_CMD_TCP_CONNECT			0x01
#define	SOCKS5_ADDR_IPV4			0x01
#define SOCKS5_RESPONSE_GRANTED         	0x00
#define	SOCKS5_RESPONSE_FAILURE			0x01
#define	SOCKS5_RESPONSE_NOT_ALLOWED		0x02
#define	SOCKS5_RESPONSE_NET_UNREACHABLE		0x03
#define	SOCKS5_RESPONSE_HOST_UNREACHABLE	0x04
#define	SOCKS5_RESPONSE_REFUSED			0x05
#define	SOCKS5_RESPONSE_TTL_EXPIRED		0x06
#define	SOCKS5_RESPONSE_CMD_NOT_SUPPORTED	0x07
#define	SOCKS5_RESPONSE_ADDR_NOT_SUPPORTED	0x08

/*=[ Structs ]=*/
typedef struct
{
	unsigned char	ver;
	unsigned char	auth_count;	// we will set it always to 1
	unsigned char	auth_method;	
}s_socks5_handshake;

typedef struct
{
	unsigned char   ver;
	unsigned char   cmd;
	unsigned char	res;		// reserverd, must be 0
	unsigned char	addr_type;
	unsigned int    ip;
	unsigned short  port;
}s_socks5_request;

/*=[ Prototypes ]=*/
void socks5_connect(s_libnet *);

#endif
