/*
 * Huk: a multi-threaded modular bruteforce tool 
 *
 * Written by Carlos Barros <barros [at] barrossecurity [dot] com>
 *
 * Copyright (C) 2006, Barrossecurity
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __WRAPPERS_H__
#define __WRAPPERS_H__

#include <sys/mman.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <dirent.h>

/*=[ Prototypes ]*/
FILE *do_fopen(const char *, const char *);
size_t do_fwrite(const void *, size_t, size_t, FILE *);
int do_fseek(FILE *, long, int);
long do_ftell(FILE *);
size_t do_fread(void *, size_t, size_t, FILE *);
char *do_fgets(char *, int, FILE *);
void *do_mmap(void *, size_t, int, int, int, off_t);
int do_munmap(void *, size_t);
void *do_malloc(size_t);
void *do_calloc(size_t, size_t);
void *do_realloc(void *,int);
char *do_strdup(const char *);
int do_socket(int, int, int);
int do_connect(int, const struct sockaddr *, socklen_t);
void *do_memdup(void *, int);
DIR *do_opendir(const char *);
int do_stat(const char *, struct stat *);

#endif
