/*
 * Huk: a multi-threaded modular bruteforce tool 
 *
 * Written by Carlos Barros <barros [at] barrossecurity [dot] com>
 *
 * Copyright (C) 2006, Barrossecurity
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __MODULES_H__
#define __MODULES_H__

#include <libhuk/libnet.h>
#include <libhuk/list.h>

/* modules object is divided into two files.
** one file is located into the libhuk and another
** is staticaly linked into huk. This division 
** was defined this way cause libhuk does not need
** all methods exported by modules object.
*/
#include <libhuk/modules.h>

/*=[ Defines ]=*/
#define	MODULE_USAGE_TRIGGER	"help"
#define MODULES_DIRECTORY	PREFIX"/share/huk/"

/*=[ Structs ]=*/

typedef struct
{
	void			*dl_handle;
	s_module_definition	*m_definition;
}s_module_entry;

/*=[ Prototypes ]=*/
void modules_get_modules(void);
void modules_free(void);
void modules_free_module(void *);
void modules_list(void);
void modules_usage(s_module_definition *);
void modules_append_param(s_linked_list **, char *);
void modules_clean_param(void *);
void modules_check_params(s_module_definition *, s_linked_list **);
s_module_definition *modules_locate(char *);

#endif
