/*
 * Huk: a multi-threaded modular bruteforce tool 
 *
 * Written by Carlos Barros <barros [at] barrossecurity [dot] com>
 *
 * Copyright (C) 2006, Barrossecurity
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __WLIST_H__
#define __WLIST_H__

/*=[ Defines ]=*/
#define	MAX_WORD	64

/*=[ Structs ]=*/

typedef struct
{
	char	*user_list;
	FILE	*user_fptr;

	char	*passwd_list;
	FILE	*pass_fptr;

	char	*combo_list;
	FILE	*combo_fptr;

	char	*single_user;
	char	*single_passwd;

	int	entry_count;
	int	total_read;

	char	username[MAX_WORD];
	char	password[MAX_WORD];
}s_wlist;

/*=[ Prototypes ]=*/
s_wlist *wlist_open(char *, char *, char *, char *, char *);
void wlist_close(s_wlist *);
int wlist_read(s_wlist *);
void wlist_goto_entry(s_wlist *, int);
void wlist_reset(s_wlist *);
int wlist_count_entries(s_wlist *);

#endif
